# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class ChangeInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'when': 'datetime',
        'who': 'str'
    }

    attribute_map = {
        'when': 'when',
        'who': 'who'
    }

    def __init__(self, when=None, who=None, local_vars_configuration=None):  # noqa: E501
        """ChangeInfo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._when = None
        self._who = None
        self.discriminator = None

        if when is not None:
            self.when = when
        if who is not None:
            self.who = who

    @property
    def when(self):
        """Gets the when of this ChangeInfo.  # noqa: E501

        The date of the executed event  # noqa: E501

        :return: The when of this ChangeInfo.  # noqa: E501
        :rtype: datetime
        """
        return self._when

    @when.setter
    def when(self, when):
        """Sets the when of this ChangeInfo.

        The date of the executed event  # noqa: E501

        :param when: The when of this ChangeInfo.  # noqa: E501
        :type: datetime
        """

        self._when = when

    @property
    def who(self):
        """Gets the who of this ChangeInfo.  # noqa: E501

        The user who executed the event  # noqa: E501

        :return: The who of this ChangeInfo.  # noqa: E501
        :rtype: str
        """
        return self._who

    @who.setter
    def who(self, who):
        """Sets the who of this ChangeInfo.

        The user who executed the event  # noqa: E501

        :param who: The who of this ChangeInfo.  # noqa: E501
        :type: str
        """

        self._who = who

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ChangeInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ChangeInfo):
            return True

        return self.to_dict() != other.to_dict()
